<script setup lang="ts">
import { useReceipetStore } from '@/stores/receipt'
import { useMembersStore } from '@/stores/member'
import { useDateStore } from '@/stores/date';
import jsPDF from 'jspdf'
import html2canvas from 'html2canvas'

const memberStore = useMembersStore()
const receiptStore = useReceipetStore()
const dateStore = useDateStore()
function confirm() {
  //receiptStore.addReceipt()
  receiptStore.removePoint()
  receiptStore.addPoint()
  receiptStore.receiptDialog = false
  receiptStore.clear()
  savePDF()
}

function savePDF() {
  const receipt = document.getElementById('receipt')
  html2canvas(receipt!).then(canvas => {
    const imageData = canvas.toDataURL('image/png')
    const pdf = new jsPDF()
    pdf.addImage(imageData, 'PNG', 10, 10, 100, 140)
    pdf.save('receipt.pdf')
  })
}
</script>

<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
    <v-card>
      <div id="receipt">
        <v-card-title class="text-h4" style="text-align: center">Receipt</v-card-title>
        <v-card-text>
          <v-row>D-Coffee</v-row>
          <v-row>Date {{ dateStore.currentDate() }}</v-row>
          <v-row>______________________________________________________</v-row>
          <v-row
            ><v-col>Employee</v-col><v-col></v-col
            ><v-col>{{ receiptStore.receipt!.user?.fullName }}</v-col></v-row
          >
          <v-row
            ><v-col>Member</v-col><v-col></v-col
            ><v-col>{{
              memberStore.editedMember && memberStore.editedMember.name ? memberStore.editedMember.name : '-'
            }}</v-col></v-row
          >
          <v-row
            ><v-col>Point</v-col><v-col></v-col
            ><v-col>{{
              memberStore.editedMember && memberStore.editedMember.point ? memberStore.editedMember.point : '-'
            }}</v-col></v-row
          >
          <v-row
            ><v-col>Payment</v-col><v-col></v-col
            ><v-col>{{ receiptStore.receipt!.paymentType }}</v-col></v-row
          >
          <v-row>______________________________________________________</v-row>
          <v-row><v-col>MenuList</v-col></v-row>
          <v-row v-for="(item, index) in receiptStore.receipt!.recieptItem" :key="index">
            <v-col>{{ item.name }}</v-col
            ><v-col>{{ item.unit }} x {{ item.price }} </v-col
            ><v-col>{{ item.price * item.unit }}</v-col>
          </v-row>
          <v-row>______________________________________________________</v-row>
          <v-row
            ><v-col>Total</v-col><v-col></v-col
            ><v-col>{{ receiptStore.receipt!.totalBefore }}</v-col></v-row
          >
          <v-row
            ><v-col>Discount</v-col><v-col></v-col
            ><v-col>{{ receiptStore.receipt!.memberDiscount }}</v-col></v-row
          >
          <v-row>______________________________________________________</v-row>
          <v-row
            ><v-col>Received</v-col><v-col></v-col
            ><v-col v-if="receiptStore.receipt!.paymentType === 'scan'">{{
              receiptStore.receipt!.total
            }}</v-col>
            <v-col v-if="receiptStore.receipt!.paymentType === 'cash'">{{
              receiptStore.receipt!.receicedAmount
            }}</v-col>
          </v-row>
          <v-row
            ><v-col>Change</v-col><v-col></v-col
            ><v-col>
              {{ receiptStore.receipt!.change }}
            </v-col>  
          </v-row>
          <v-row>====================================================</v-row>
          <v-row
            ><v-col style="font-size: x-large; font-style: inherit">NetTotal</v-col><v-col></v-col
            ><v-col style="font-size: x-large; font-style: inherit">{{
              receiptStore.receipt!.total
            }}</v-col></v-row
          >
          <v-row>====================================================</v-row>
          <v-row></v-row>
          <v-row style="display: flex; justify-content: center; align-items: center; font-size: 16pt;">Thank You</v-row>
        </v-card-text>
      </div>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="green-darken-1" variant="text" @click="receiptStore.receiptDialog = false">
            Cancel
          </v-btn>
          <v-btn color="green-darken-1" variant="text" @click="confirm()"> Confirm</v-btn>
        </v-card-actions>
    </v-card>
  </v-dialog>
</template>
